codeforces 295B B. Greg and Graph(floyd+dp)

题目链接:

codeforces 295B


题目大意:

给出n个点的完全有权有向图,每次删去一个点,求每次操作前整张图各个点的最短路之和。


题目分析:

  • 首先删边对于我们来说是不好做的,所以我们想到了通过加点的方式逆向地做,那么加点怎么做呢?
  • 其实就是一个我们很熟悉的算法:floyd,因为我们通常用的都是它的简化版本,所以可能很多人并不理解它的确切的思想。
  • 在介绍这道题的具体解法之前,我先解释一下floyd,可能之后的问题就迎刃而解了。
  • 首先floyd其实是动态规划,没有省略时的状态是这样定义的。dp[k][i][j]代表前k个点作为媒介的情况下i到j的最短路。
  • 转移方程也很简单,如下:

    dp[k][i][j]=min(dp[k?1][i][j],dp[k?1][i][k]+dp[k?1][k][j])
  • 这样我们就知道了n3的递推中,最后一维其实标记的是作为媒介的点是前k个的情况,那么也就是我们之要1~k这些点组成图的最短路,那么因为在求取最短路时,并没有用后面的点作为媒介,所以就是我们要的答案,因为加入点无序,所以我们要先用hash将点对应到有序的序列上,然后直接利用floyd做就可以了,不懂的可以在评论中询问,我会耐心解答的。

AC代码:

#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <algorithm>
#include <map>
#define MAX 507

using namespace std;

typedef long long LL;

LL dp[MAX][MAX],ans[MAX],a[MAX][MAX];
int n,x[MAX];
map<int,int> mp;

int main ( )
{
    while (~scanf ( "%d" , &n ))
    {
        mp.clear();
        for ( int i = 1 ; i <= n ; i++ )
            for ( int j = 1 ; j <= n ; j++ )
                scanf ( "%I64d" , &a[i][j] );
        for ( int i = 1 ; i <= n ; i++ )
        {
            scanf ( "%d" , &x[i] );
            mp[x[i]] = n+1-i;
        }
        for ( int i = 1 ; i <= n ; i++ )
            for ( int j = 1 ; j <= n ; j++ )
                dp[mp[i]][mp[j]] = a[i][j];
        for ( int k = 1; k <= n ; k++ )
        {
            for ( int i = 1 ; i <= n ; i++ )
                for ( int j = 1 ; j <= n ; j++ )
                    dp[i][j] = min ( dp[i][j] , dp[i][k] + dp[k][j] );
            for ( int i = 1 ; i <= k; i++ )
                for ( int j = 1 ; j <= k; j++ )
                    ans[n-k+1] += dp[i][j];
        }
        for ( int i = 1 ; i <= n ; i++ )
            printf ( "%I64d " , ans[i] );
        puts ("");
    }
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-10-12 12:51:37

codeforces 295B B. Greg and Graph(floyd+dp)的相关文章

Greg and Graph+floyd算法的应用

Greg and Graph time limit per test 3 seconds memory limit per test 256 megabytes input standard input output standard output Greg has a weighed directed graph, consisting of n vertices. In this graph any pair of distinct vertices has an edge between

【CodeForces - 296D】Greg and Graph(floyd)

Description 题意:给定一个有向图,一共有N个点,给邻接矩阵.依次去掉N个节点,每一次去掉一个节点的同时,将其直接与当前节点相连的边和当前节点连出的边都需要去除,输出N个数,表示去掉当前节点之前的所有两点间最短距离和.n<=500 Solution 如果暴力打肯定是会超时的,那就要运用到floyd(hj) floyd算法内2个循环就相当于新加入外循环的那个点然后跟新最短路, 所以可以把题目看成倒过来依次加点,每次\(n^2\)平方更新一下,总共\(O(n^3)\) Code #incl

295B - Greg and Graph (floyd逆序处理)

题意:给出任意两点之间的距离,然后逐个删除这些点和与点相连的边,问,在每次删除前的所有点对的最短距离之和 分析:首先想到的是floyd,但是如果从前往后处理,复杂度是(500)^4,超时,我们从后往前处理,这样我们可以看作是添加点,而且这样的话每次只需要考虑添加点的缩进,所以复杂度是(500)^3,注意,我们每次添加一个点,就给他一个标记,代表这个点已经添加,然后算距离的时候,只有添加过的点才能加上距离 代码: #include <bits/stdc++.h> using namespace

Problem B Codeforces 295B 最短路(floyd)

Description Greg has a weighed directed graph, consisting of n vertices. In this graph any pair of distinct vertices has an edge between them in both directions. Greg loves playing with the graph and now he has invented a new game: The game consists

HDU 4034 Graph(floyd,最短路,简单)

题目 一道简单的倒着的floyd. 具体可看代码,代码可简化,你有兴趣可以简化一下,就是把那个Dijsktra所实现的功能放到倒着的floyd里面去. #include<stdio.h> #include<string.h> #include<algorithm> using namespace std; const int MAXN=110; const int INF=0x3f3f3f3f;//防止后面溢出,这个不能太大 bool vis[MAXN]; int pr

hdu4034 Graph(floyd)

题目:  给出一个图的最短路,求原图最少几条边 Graph Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65768/65768 K (Java/Others)Total Submission(s): 1695    Accepted Submission(s): 848 Problem Description Everyone knows how to calculate the shortest path in a direc

codeforces 161D - Distance in Tree(树形dp)

题目大意: 求出树上距离为k的点对有多少个. 思路分析: dp[i][j] 表示 i 的子树中和 i 的距离为 j 的点数有多少个.注意dp[i] [0] 永远是1的. 然后在处理完一颗子树后,就把自身的dp 更新. 更新之前更新答案. 如果这颗子树到 i 有 x 个距离为j的.那么答案就要加上 dp[i] [ k-j-1] * x; #include <iostream> #include <cstdio> #include <cstring> #include &l

CodeForces 258B Little Elephant and Elections 数位DP

前面先用数位DP预处理,然后暴力计算组合方式即可. #include <cstdio> #include <cstring> #include <cmath> #include <algorithm> #include <climits> #include <string> #include <iostream> #include <map> #include <cstdlib> #include

Codeforces 437E The Child and Polygon(区间DP)

题目链接:Codeforces 437E The Child and Polygon 题目大意:给出一个多边形,问说有多少种分割方法,将多边形分割为多个三角形. 解题思路:首先要理解向量叉积的性质,一开始将给出的点转换成顺时针,然后用区间dp计算.dp[i][j]表示从点i到点j可以有dp[i][j]种切割方法.然后点i和点j是否可以做为切割线,要经过判断,即在i和j中选择的话点k的话,点k要在i,j的逆时针方. #include <cstdio> #include <cstring&g